<?php


function recommender_settings_form() {
  $form = array();

  /*$form['settings'] = array(
    '#type' => 'fieldset',
    '#collapsible' => FALSE,
    '#collapsed' => FALSE,
    '#title' => t('Settings'),
    '#description' => t('Change settings for Recommender API based modules.'),
  );

  $form['settings']['cron_freq'] = array(
    '#title' => t('Recommender running frequency in cron job.'),
    '#type' => 'select',
    '#default_value' => variable_get('recommender_cron_freq', 'never'),
    '#options' => array(
      'never' => 'Never',
      'immediately' => 'Immediately',
      'hourly' => t('Hourly'),
      'every6hr' => t('Every 6 hours'),
      'every12hr' => t('Every 12 hours'),
      'daily' => t('Daily'),
      'weekly' => t('Weekly')
    ),
    '#description' => t("Please specify the optional frequency to run recommender algorithms in cron. Note that this is a time consuming operation and might timeout or affect your other cron tasks. Not recommended for large site. Consider using the Drush script with system cron.")
  );

  $form['settings']['save'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
    '#name' => 'save'
  );*/

  $form['run'] = array(
    '#type' => 'fieldset',
    '#collapsible' => FALSE,
    '#collapsed' => FALSE,
    '#title' => t('Run recommender'),
    '#description' => t('Running recommender involves complex matrix computation and could probably take some time. Please be patient. You can also run recommender with Drush.'),
  );


  $rows = db_query("SELECT name, title FROM {recommender_app} ORDER BY name");
  if (empty($rows)) {
    $form['run']['note'] = array(
      '#title' => 'Note',
      '#type' => 'item',
      '#description' => t('No recommender modules available.'),
    );
  }
  else {
    $options = array();
    foreach ($rows as $row) {
      $options[$row->name] = $row->title;
    }

    $form['run']['apps'] = array(
      '#title' => t('Choose recommender applications'),
      '#default_value' => variable_get('recommender_apps', array()),
      '#type' => 'checkboxes',
      '#description' => t('Please select which recommender applications to run.'),
      '#options' => $options,
    );
  }

  $form['run']['run'] = array(
    '#type' => 'submit',
    '#value' => t('Run recommender now'),
    '#name' => 'run',
    '#disabled' => $options == NULL ? TRUE : FALSE,
  );


  $recent_command = async_command_retrieve_command_list('recommender');
  $history_list = theme('async_command_list', array(
    'command_list' => $recent_command,
    'cols' => array('uid','command','created','changed','status','message')
  ));
  $form['history'] = array(
    '#markup' => $history_list,
  );

  return $form;
}


function recommender_settings_form_submit($form, &$form_state) {
  //$cron_freq = $form_state['values']['cron_freq'];
  $apps = $form_state['values']['apps'];

  //variable_set('recommender_cron_freq', $cron_freq);
  variable_set('recommender_apps', $apps);

  if ($form_state['clicked_button']['#name'] == 'save') {
    drupal_set_message(t("The configuration options have been saved."));
  }
  else {
    // trigger recommender_run()
    foreach ($apps as $app_name) {
      if (!empty($app_name)) {
        recommender_create_command($app_name);
      }
    }
  }
}


 
